stages:
  - lint
  - test
  - build
  - integration
  - generate_release
  - release

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest
  CONTAINER_BUILDER_IMAGE: $CI_REGISTRY_IMAGE:builder

include:
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-commitchecker.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-lintdocs.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-generate-release.yml
    ref: master

lint:
  stage: lint
  image: python:3.7
  before_script:
    - pip install tox
  script:
    tox -e lint
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
  only:
    refs:
      - merge_requests
      - master
      - tags

unit:
  stage: test
  image: python:3.7
  coverage: '/total_coverage: ([0-9]{1,3})/'
  before_script:
    - pip install tox
  script:
    tox -e unittest
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
  only:
    refs:
      - merge_requests
      - master
      - tags

build:
  services:
    - docker:18.09.7-dind
  image: docker:18-git
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $CONTAINER_BUILDER_IMAGE || true
    - docker build
      --target builder
      --cache-from $CONTAINER_BUILDER_IMAGE
      -t $CONTAINER_BUILDER_IMAGE
      "."
    - docker pull $CONTAINER_RELEASE_IMAGE || true
    - docker build --pull
      --cache-from $CONTAINER_BUILDER_IMAGE
      --cache-from $CONTAINER_RELEASE_IMAGE
      -t $CONTAINER_TEST_IMAGE
      "."
    - docker push $CONTAINER_TEST_IMAGE
    - docker push $CONTAINER_BUILDER_IMAGE
  only:
    - merge_requests
    - master

downstream:
  variables:
    gman: "{'gman': {'image': \'$CI_REGISTRY_IMAGE\', 'tag': \'$CI_COMMIT_REF_SLUG\'}}"
    TYPE: functional
  stage: integration
  only:
    - merge_requests
    - master
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore/
  trigger:
    project: dreamer-labs/piperci/piperci-integration
    strategy: depend

release-image:
  services:
    - docker:18.09.7-dind
  image: docker:18-git
  stage: release
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - tag=$(cat VERSION)
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CI_REGISTRY_IMAGE:$tag
    - docker push $CONTAINER_RELEASE_IMAGE
    - docker push $CI_REGISTRY_IMAGE:$tag
  only:
    refs:
      - master
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
